﻿//Liste des paramètres disponibles dans le panneau des propriétés
/*
Inspectable est une "balise" de type metadata interprètée par flash.
Dans notre exemple, la structure est toujours la même
	-name représente ce qui va être affiché dans le panneau des propriétés
	-variable est le nom de la variable qui stockera la valeur entrée
	-type est le type de variable
	-defaultValue est la valeur par défaut si l'utilisateur n'attribue pas d'autre valeur
	-enumation permet d'afficher une liste de valeurs à l'utilisateur
*/
[Inspectable(name="Largeur Images", variable="imgwidth", type="Number", defaultValue=100)]	
[Inspectable(name="Fichier XML", variable="xmlfile", type="String",defaultValue="")]	
[Inspectable(name="Fonction associée", variable="onpressevent", type="String",defaultValue="")]	
[Inspectable(name="Alpha", variable="playalpha", enumation "true,false" ,type="Boolean",defaultValue=false)]	
[Inspectable(name="Fichier Son", variable="soundfile", type="String",defaultValue="")]	

dynamic class Banner extends MovieClip {
   public var __imageWidth:Number;   
   public var __xmlFile:String;   
   private var _XmlParser:XML;
   public var __ImagesArray:Array;
   public var __left:Number=0;
   public var __function:String;
   public var __alpha;
   public var __sound:Sound;
   public var __soundFile:String;   

   function Banner(){	      
        this.init();
   }
  
   function init() {         
   		__imageWidth=this.imgwidth;  
		__xmlFile=this.xmlfile;
		__function=this.onpressevent;
		__alpha=this.playalpha;
		__soundFile=this.soundfile;
		if(__soundFile != ""){
			__sound=new Sound();			

			__sound.onLoad=function(success){
				if(success){
					this.__soundOk=true;
				}

			}
			__sound.loadSound(__soundFile,false);
		}		
		
		if(__xmlFile != ""){
			this.ParseXml();
		}
		
   } 
   private function ParseXml(){	   
	   XmlParser=new XML();
	   XmlParser.Owner=this;
	   XmlParser.onLoad=function(success){		   
		   if(success){
			   XmlParser.Owner.__ImagesArray=new Array();			   
			   for(i=0;i<this.firstChild.childNodes.length;i++){
				   if(this.firstChild.childNodes[i].attributes.path != undefined){
					   XmlParser.Owner.__ImagesArray.push(this.firstChild.childNodes[i].attributes.path);
				   }
				}
				XmlParser.Owner.BuildClip();
		   }
	   }
	   XmlParser.load(__xmlFile);
	}
	   
	   
   
   private function BuildClip(){	   
	   for(i=0;i<__ImagesArray.length;i++){
		   this.createEmptyMovieClip("img"+i,i);
		   if(__function != ""){					
		   		this["img"+i].Owner=this;					
				this["img"+i].onPress=function(){
					if(this.Owner.__sound.__soundOk){
						this.Owner.__sound.start();
					}
					eval(this.Owner.__function)(this); 
				}
		   }
		   
		   if(__alpha){

			   this["img"+i].onRollOver=function(){
					this._alpha=50; 
				}
			   this["img"+i].onRollOut=function(){
					this._alpha=100; 
				}				
		   }
				
		   this["img"+i].createEmptyMovieClip("sub_img"+i,i);
	   		with (this["img"+i]["sub_img"+i]) {
				_x=this.__left;
				_y=20;
				loadMovie(this.__ImagesArray[i]);				
			}
			__left+=__imageWidth;
	   }
	   
	   this._parent._parent.onMouseMove=function(){
			this.redraw(true);
	   }
   }

}